package io.tswf.transmutations.transmute.annotation;

import io.tswf.transmutations.common.annotation.ClassReference;
import io.tswf.transmutations.common.annotation.MethodDescription;
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface Transmute {
    ClassReference targetClass() default @ClassReference;
    MethodDescription targetMethod() default @MethodDescription(name = "");
    MissingTargetStrategy onMissing() default MissingTargetStrategy.WARNING;
    At[] at() default {};
    DependedAt[] dependedAt() default {};
}
