package io.tswf.transmutations.transmute.injection.contexts

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.util.CustomPayload
import io.tswf.transmutations.transmute.util.ICustomPayload
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.AbstractInsnNode
import org.objectweb.asm.tree.InsnList

@CheckedMapConstructor
@CompileStatic
class TransmutationInjectionToMethodAtInsnContext {
    AbstractInsnNode startInsn
    AbstractInsnNode currentInsn = null
    InsnList insnsToInsertToCurrent = new InsnList()
    TransmutationInjectionToMethodContext allPointsContext
    InjectionStatus injectionStatus = InjectionStatus.PENDING
    ICustomPayload customPayload = new CustomPayload()

    void commit() {
        if (!insnsToInsertToCurrent.isEmpty()) {
            def newCurrent = insnsToInsertToCurrent.last
            allPointsContext.targetMethod.instructions.insertAfter(currentInsn, insnsToInsertToCurrent)
            currentInsn = newCurrent
            insnsToInsertToCurrent.clear()
        }
    }
}

enum InjectionStatus {
    PENDING,
    PROCESSING,
    DONE
}

enum InjectionOffset {
    AFTER,
    BEFORE,
    NO
    ;
    public static final InjectionOffset DEFAULT = NO
}
