package io.tswf.transmutations.transmute.injection.missing.logic

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.exception.MissingTransmutationTargetMethodException
import io.tswf.transmutations.transmute.injection.missing.IMissingTargetStrategyLogic
import io.tswf.transmutations.transmute.injection.missing.MissingTargetHandleContext
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy

@AutoService(IMissingTargetStrategyLogic)
@CompileStatic
class ThrowMissingTargetStrategyLogic implements IMissingTargetStrategyLogic {

    @Override
    void handleMissingTarget(MissingTargetHandleContext context) {
        throw new MissingTransmutationTargetMethodException(context.transmutationMethodMeta, context.targetClass)
    }

    @Override
    MissingTargetStrategy getEnumValue() {
        return MissingTargetStrategy.THROW
    }
}
