package io.tswf.transmutations.transmute.injection.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.AtHead
import io.tswf.transmutations.transmute.exception.InvalidTransmutationDescriptionException
import org.objectweb.asm.tree.AbstractInsnNode

@AutoService(ITransmutationInjectionPoint)
@CompileStatic
class MethodHeadTransmutationInjectionPoint implements ITransmutationInjectionPoint {

    @Override
    AbstractInsnNode findNextNodeNearInject(InjectionPointSearchContext context) {
        if (context.transmutationTargetMethodNode.name == "<init>") {
            throw new InvalidTransmutationDescriptionException("Can't inject into HEAD of constructor! Please, use another injection methods instead!")
        }

        if (context.transmutationTargetMethodNode.instructions.first === context.insnFromSearch) {
            return context.insnFromSearch
        }

        return null
    }
}
