package io.tswf.transmutations.transmute.injection.reader

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.injection.ITransmutationMethodReturnValueProcessor
import io.tswf.transmutations.transmute.meta.TransmutationMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor

@CompileStatic
interface IReturnValueProcessorReader {
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext)
}

@CheckedMapConstructor
@CompileStatic
class ReturnValueProcessorReadingContext {
    TransmutationMethodMetadata transmutationMetadata
    List<ITransmutationMethodReturnValueProcessor> readedProcessors = new ArrayList<>()
}