package io.tswf.transmutations.transmute.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.injection.returnvalue.NopReturnValueProcessor
import org.objectweb.asm.Type

@AutoService(IReturnValueProcessorReader)
@CompileStatic
class NopReturnValueVoidProcessorReader implements IReturnValueProcessorReader {

    @Override
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.returnType.descriptor == Type.VOID_TYPE.descriptor) {
            readingContext.readedProcessors << new NopReturnValueProcessor()
        }
    }
}
