package io.tswf.transmutations.transmute.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.ReturningConstantIfTrue
import io.tswf.transmutations.transmute.annotation.ReturningVoidIfTrue
import io.tswf.transmutations.transmute.injection.returnvalue.ReturnConstantIfTransmutationTrueReturnValueProcessor
import io.tswf.transmutations.transmute.injection.returnvalue.ReturnVoidIfTransmutationTrueReturnValueProcessor
import org.objectweb.asm.tree.AnnotationNode

@AutoService(IReturnValueProcessorReader)
@CompileStatic
class ReturningVoidIfTrueProcessorReader implements IReturnValueProcessorReader {

    @Override
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasAnnotation(ReturningVoidIfTrue)) {
            readingContext.readedProcessors << new ReturnVoidIfTransmutationTrueReturnValueProcessor()
        }
    }
}
