package io.tswf.transmutations.transmute.injection.reader

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.Transmute
import io.tswf.transmutations.transmute.meta.TransmutationMethodMetadata
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class TransmutationClassReader {

    static List<TransmutationMethodMetadata> readAllTransmutationsInClass(ClassNode transmutationsClass) {
        return transmutationsClass.methods
            .stream()
                .filter { it.hasAnnotation(Transmute) }
                .map { TransmutationMetadataReader.readTransmutationMetadata(transmutationsClass, it) }
                .toList()
    }
}
